/*
 * SPDX-FileCopyrightText: 2018 Bruce Cowan <bruce@bcowan.me.uk>
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#include <stdio.h>
#include <tgmath.h>

int
main (void)
{
    double complex z1 = I*I;
    printf("j * j = %.1f + j%.1f\n", creal (z1), cimag (z1));
    
    double complex z2 = pow (I, 2);
    printf("j^2 = %.1f + j%.1f\n", creal (z2), cimag (z2));
    
    double complex z3 = exp (I * M_PI);
    printf("exp(j * pi) = %.1f + j%.1f\n", creal (z3), cimag (z3));
    
    double complex z4 = 1 + 2*I;
    double complex z5 = 1 - 2*I;
    printf ("(1+j2)(1-j2) = %.1f + j%.1f\n", creal (z4*z5), cimag (z4*z5));

    return 0;
}
